stages:
  - deploy
  - destroy



default:
  tags:
    - fast

include:
  - local: "/ci-templates/extensions/.gitlab-ci-anchors.yml"

variables:
  GITLAB_ENV_NAME: staging-networking
  VPC_CIDR: "10.5.0.0/16"
  PROJECT_ID: $CI_PROJECT_ID
  PROJECT_NAME: $CI_PROJECT_NAME


.vars-overwrite:  #(define variables in extension for overwrite variable defined in ".gitlab-ci-anchor.yml" extension file )
  variables:
    TF_ENVIRONMENT: staging
    BACKEND_ENV_DIR: staging

# ------------------------------------------------ OPTIONNAL STAGING NETWORK---------------------------------------------------------------------------


optional:aws_staging_network:prepare:
  stage: deploy
  extends:
    - .optional:aws_staging_network:prepare
    - .vars-overwrite #---> overwrite varaibles in ".optional:aws_staging_network:prepare" exention
  when: manual
  environment:
    name: $GITLAB_ENV_NAME
    action: start
    on_stop: "optional:aws_staging_network:destroy"
  rules:
    - if: $CI_COMMIT_BRANCH == "production"


optional:aws_staging_network:destroy:
  stage: destroy
  extends:
    - .optional:aws_staging_network:destroy
    - .vars-overwrite #---> overwrite varaibles in ".optional:aws_staging_network:destroy" exention
  when: manual
  environment:
    name: $GITLAB_ENV_NAME
    action: stop
  rules:
    - if: $CI_COMMIT_BRANCH == "production"

